## Name

vacuumdb — garbage-collect and analyze a PostgreSQL database

## Synopsis

`vacuumdb` [`connection-option`...] [[--full] | [-f]] [[--verbose] | [-v]] [[--analyze] | [-z]] [--table | -t `table` [( `column` [,...] )] ] [`dbname`]
`vacuumdb` [`connection-options`...] [[--all] | [-a]] [[--full] | [-f]] [[--verbose] | [-v]] [[--analyze] | [-z]]

## Description

vacuumdb is a utility for cleaning a PostgreSQL database. vacuumdb will also generate internal statistics used by the PostgreSQL query optimizer.

vacuumdb is a wrapper around the SQL command VACUUM. There is no effective difference between vacuuming databases via this utility and via other methods for accessing the server.

## Options

vacuumdb accepts the following command-line arguments:

`-a`
`--all`

  Vacuum all databases.

`[-d] `dbname``
`[--dbname] `dbname``

  Specifies the name of the database to be cleaned or analyzed. If this is not specified and `-a` (or `--all`) is not used, the database name is read from the environment variable `PGDATABASE`. If that is not set, the user name specified for the connection is used.

`-e`
`--echo`

  Echo the commands that vacuumdb generates and sends to the server.

`-f`
`--full`

  Perform “full” vacuuming.

`-q`
`--quiet`

  Do not display a response.

`-t `table` [ (`column` [,...]) ]`
`--table `table` [ (`column` [,...]) ]`

  Clean or analyze `table` only. Column names may be specified only in conjunction with the `--analyze` option.

  ### Tip

  If you specify columns, you probably have to escape the parentheses from the shell. (See examples below.)

`-v`
`--verbose`

  Print detailed information during processing.

`-z`
`--analyze`

  Calculate statistics for use by the optimizer.

vacuumdb also accepts the following command-line arguments for connection parameters:

`-h `host``
`--host `host``

  Specifies the host name of the machine on which the server is running. If the value begins with a slash, it is used as the directory for the Unix domain socket.

`-p `port``
`--port `port``

  Specifies the TCP port or local Unix domain socket file extension on which the server is listening for connections.

`-U `username``
`--username `username``

  User name to connect as

`-W`
`--password`

  Force password prompt.

## Environment

`PGDATABASE`
`PGHOST`
`PGPORT`
`PGUSER`

  Default connection parameters

## Diagnostics

In case of difficulty, see VACUUM and psql for discussions of potential problems and error messages. The database server must be running at the targeted host. Also, any default connection settings and environment variables used by the libpq front-end library will apply.

## Notes

vacuumdb might need to connect several times to the PostgreSQL server, asking for a password each time. It is convenient to have a `~/.pgpass` file in such cases. See Section 28.12, “The Password File” for more information.

## Examples

To clean the database `test`:

    $ vacuumdb test

To clean and analyze for the optimizer a database named `bigdb`:

    $ vacuumdb --analyze bigdb

To clean a single table `foo` in a database named `xyzzy`, and analyze a single column `bar` of the table for the optimizer:

    $ vacuumdb --analyze --verbose --table 'foo(bar)' xyzzy

## See Also

VACUUM, Environment Variables (Section 28.11, “Environment Variables”)